#define MAX_PATH 260

#include "GMLuaModule.h"
#include "csimplescan.h"
#include <csimpledetour.h>
#include <stdlib.h>
#include <Windows.h>
#include <convar.h>

GMOD_MODULE( Init, Shutdown );
 
ILuaInterface* g_Lua;

ICvar * Convar = NULL;

const char * CallLuaHook(const char* name, const char* disconnectstring){
	ILuaObject *hookT = g_Lua->GetGlobal("hook");
	ILuaObject *callM = hookT->GetMember("Call");
	g_Lua->Push(callM);
	g_Lua->Push(name);
	g_Lua->PushNil();
	g_Lua->Push(disconnectstring);
	callM->UnReference();
	hookT->UnReference();

	g_Lua->Call(3, 1);

	ILuaObject *retL = g_Lua->GetReturn(0);

	if(!retL->isNil()) {
		return g_Lua->GetString(0);
	}
	return disconnectstring;
}

class detours
{
public:
	void Disconnect_H(char const * a);
	static void (detours:: *Disconnect_T)(char const * a);
};
void (detours:: *detours::Disconnect_T)(char const * a) = NULL;

SETUP_SIMPLE_DETOUR(Disconnect_Detour, detours::Disconnect_T, detours::Disconnect_H);

void detours::Disconnect_H(char const * a)
{
	(this->*Disconnect_T)(CallLuaHook("DisconnectMsg", a));
}

int Init( lua_State *L )
{
	g_Lua = Lua();

	CSimpleScan engineInterface("engine.dll");
	if(engineInterface.FindFunction((const unsigned char *)"\x53\x56\x8B\xF1\x33\xDB\x39\x9E\x8C\x00\x00\x00\x0F\x8C\x29\x01\x00\x00\x8B\x06\x8B", "xxxxxxxxx???x?????xxx", (void **)&detours::Disconnect_T))
	{
		Disconnect_Detour.Attach();
		g_Lua->Msg("gmcl_disconnect Succesfully Intalized.\nMade by ColdFusion 11/21/2010\n");
		return 0;
	}
	g_Lua->Msg("gmcl_disconnect: Sigscan failed\ngmcl_disconnect Failed to Intalize\n");
	return 0;
}
int Shutdown( lua_State *L )
{
	Disconnect_Detour.Detach();
	return 0;
}

/*
Unkown Disconnect function.

sig:
\x53\x56\x8B\xF1\x33\xDB\x39\x9E\x8C\x00\x00\x00\x0F\x8C\x29\x01\x00\x00\x8B\x06\x8B\x90\x8C\x00\x00\x00\x55\x57

mask:
xxxxxxxxxxxxx?????xxxxxxxxxx

length=28
*/